/**************************************************************************
*  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
*  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
*                                                                         *
*  Merc Diku Mud improvements copyright (C) 1992, 1993 by Michael         *
*  Chastain, Michael Quan, and Mitchell Tse.                              *
*                                                                         *
*  In order to use any part of this Merc Diku Mud, you must comply with   *
*  both the original Diku license in 'license.doc' as well the Merc       *
*  license in 'license.txt'.  In particular, you may not remove either of *
*  these copyright notices.                                               *
*                                                                         *
*  Much time and thought has gone into this software and you are          *
*  benefiting.  We hope that you share your changes too.  What goes       *
*  around, comes around.                                                  *
***************************************************************************
*       ROM 2.4 is copyright 1993-1998 Russ Taylor                        *
*       ROM has been brought to you by the ROM consortium                 *
*           Russ Taylor (rtaylor@hypercube.org)                           *
*           Gabrielle Taylor (gtaylor@hypercube.org)                      *
*           Brian Moore (zump@rom.org)                                    *
*       By using this code, you have agreed to follow the terms of the    *
*       ROM license, in the file Rom24/doc/rom.license                    *
***************************************************************************
*       1stMUD ROM Derivative (c) 2001-2003 by Ryan Jennings              *
*            http://1stmud.dlmud.com/  <r-jenn@shaw.ca>                   *
***************************************************************************/
#if !defined(ANSI_H)
#define ANSI_H

#define	ANSI_KEY        '{'
#define	ANSI_CUSTOM     '\x11'
#define ANSI_END	    '\x12'

#define FG_BLACK		30
#define FG_RED			31
#define FG_GREEN		32
#define FG_YELLOW		33
#define FG_BLUE			34
#define FG_MAGENTA		35
#define FG_CYAN			36
#define FG_WHITE		37
#define FG_RANDOM       -1
#define FG_NONE         0

#define BG_BLACK		40
#define BG_RED			41
#define BG_GREEN		42
#define BG_YELLOW		43
#define BG_BLUE			44
#define BG_MAGENTA		45
#define BG_CYAN			46
#define BG_WHITE		47
#define BG_RANDOM       -1
#define BG_NONE         0

#define CL_CLEAR		 0
#define CL_BRIGHT		 1
#define CL_DIM			 2
#define CL_STANDOUT      3
#define CL_UNDER		 4
#define CL_BLINK		 5
#define CL_ITALIC        6
#define CL_REVERSE		 7
#define CL_HIDDEN		 8
#define CL_RANDOM        -1

#define CT_ATTR			0
#define CT_FORE			1
#define CT_BACK			2
#define CT_MAX			3

#define CL_DEFAULT		"\033[0m"

#define CL_FORMAT1      "\033[%dm"
#define CL_FORMAT2      "\033[%d;%dm"
#define CL_FORMAT3      "\033[%d;%d;%dm"

#define ALIGN_NONE   0
#define ALIGN_LEFT   1
#define ALIGN_CENTER 2
#define ALIGN_RIGHT  3

#define _DEFAULT    0
#define	_GOSSIP1    1
#define	_GOSSIP2    2
#define	_GOSSIP3    3
#define	_MUSIC1     4
#define	_MUSIC2     5
#define	_MUSIC3     6
#define	_QA1        7
#define	_QA2        8
#define	_QA3        9
#define	_QUOTE1     10
#define	_QUOTE2     11
#define	_QUOTE3     12
#define	_GRATS1     13
#define	_GRATS2     14
#define	_GRATS3     15
#define	_SHOUT1     16
#define	_SHOUT2     17
#define	_IMMTALK1   18
#define	_IMMTALK2   19
#define	_IMMTALK3   20
#define	_TELLS1     21
#define	_TELLS2     22
#define	_SAY1       23
#define	_SAY2       24
#define	_SKILL      25
#define	_YHIT       26
#define	_OHIT       27
#define	_VHIT       28
#define	_WRACE      29
#define	_WCLASS     30
#define	_WLEVEL     31
#define	_RTITLE     32
#define	_SCORE1     33
#define	_SCORE2     34
#define	_SCORE3     35
#define	_SCOREB     36
#define	_WIZNET     37
#define _GTELL1     38
#define _GTELL2     39
#define _WHOIS1     40
#define _WHOIS2     41
#define _WHOISB     42
#define _BTALK1     43
#define _BTALK2     44
#define MAX_CUSTOM_COLOUR 45

/* ANSI_CUSTOM AND ANSI_END CHARACTERS IN STRING FORM */
#define C_START  "\x11"
#define C_END	 "\x12"

/* Convert slot numbers into strings with ANSI_CUSTOM codes */
#define cstr(s) C_START #s C_END
#define CTAG(s) cstr(s)

/* CTAG USAGE: 

    act("" CTAG(_SAY1) "$n says " CTAG(_SAY2) "' have a nice day!", ch, NULL, NULL, TO_ROOM);
    or
    sprintf(buf, "%s%s says %s' have a nice day!'\n\r", CTAG(_SAY1), ch->name, CTAG(_SAY2));
*/

#endif
